// Demo for Crispy.SpectateLib

turf/grass
	icon='grass.dmi'
	name="grass"

turf/wall
	icon='wall.dmi'
	name="wall"
	opacity=1
	density=1

turf/floor
	icon='floor.dmi'
	name="floor"

turf/New()
	..()
	//Choose a random icon state
	icon_state=pick(icon_states(icon))

obj/apple
	icon='apple.dmi'
	verb/get()
		set src in oview(1,usr)
		if(Move(usr)) usr << "You get [src]"
	verb/drop()
		set src in usr
		if(Move(usr.loc)) usr << "You drop [src]"
	Click()
		usr << "You clicked on \a [src]"
	DblClick()
		usr << "You double clicked on \a [src]"

	yellow
		icon_state="yellow"
		name="yellow apple"

obj/hud
	icon='hud.dmi'
	layer=20
	screen_loc="SOUTHEAST"
	Click()
		usr << "&copy;Copyright 2003, Crispy"
	DblClick()
		usr << "Double-click detected!"

mob/login/Login()
	switch(alert(src,"Do you want to be a spectator or a player?","Spectate?","Spectator","Player"))
		if ("Spectator")
			client.mob=new/mob/cr_watch()
		if ("Player")
			client.mob=new/mob/player()

mob/login/Logout()
	..()
	del src

mob/verb/listobjs()
	for (var/obj/O)
		src << "[O.type]: at [O.x],[O.y],[O.z] ([isnull(O.loc)? "null" : O.loc.type])"

mob/Login()
	src << "<b><font size=+1 color=blue>Welcome to the demo of \
	<a href='http://www.byond.com/hub/Crispy/SpectateLib'>Crispy.SpectateLib</a>!</font></b>"
	..()
	var/obj/hud/H=new()
	client.screen+=H

mob/Logout()
	..()
	del src

mob/npc
	icon='npc.dmi'
	density=1
	New()
		..()
		walk_rand(src,rand(3,5))

mob/cr_watch
	nomapedge=1
	allowclick=list(/obj/apple/yellow)
	loginmsg="You are a spectator. Move around using the arrow keys. You may move through \
	dense objects, but you can't see past the edge of the map (nomapedge is set to 1). \
	Notice that the get verb is not available to you. Try clicking on the red and the yellow \
	apples; also try clicking on the question mark in your HUD.\n\nIf you haven't already \
	done so, you should log in as a player and note the differences in how you are allowed to \
	interact with the world."
	New()
		////Start in the middle of the map
		//In your own game, you will probably want to make your spectators start at an
		//important point - for example, the player spawning area in an action game.
		startx=world.maxx/2
		starty=world.maxy/2
		startz=1
		..()

mob/Bump(atom/A)
	src << "Bumped \a [A]!"
	A << "[src] bumped you!"
	..()

mob/player
	icon='player.dmi'
	Login()
		..()
		src << "You are a player. Usual movement rules apply, and you can see past the edge of \
		the map, as the nomapedge var applies only to spectators. You can get and drop apples. \
		Try clicking on the red and the yellow apples, and the question mark in your HUD.\n\n\
		If you haven't already done so, log in as a spectator and note the differences."
	Stat()
		statpanel("Inventory",contents)

mob/verb/say(msg as text)
	world << "<b>[src]:</b> [html_encode(msg)]"

world
	mob=/mob/login
	turf=/turf/grass
	view="11x15"
	New()
		..()
		for (var/turf/T)
			if (T.density) continue
			if (prob(5))
				if (prob(50))
					new/obj/apple(T)
				else
					new/obj/apple/yellow(T)
			else if (prob(2)) new/mob/npc(T)